#include <fstream>
using namespace std;

ifstream cin("input.txt");
ofstream cout("output.txt");

#define MOD 1000000007

struct mat
{
	long long a[3][3];
};

mat mult(mat a, mat b)
{
	mat c;
	long long i, j, l;
	for(i=0;i<3;i++)
	{
		for(j=0;j<3;j++)
		{
			c.a[i][j]=0;
			for(l=0;l<3;l++)
			{
				c.a[i][j]+=a.a[i][l]*b.a[l][j];
				c.a[i][j]%=MOD;
			}
		}
	}

	return c;
}

mat sqr(mat a)
{
	return mult(a, a);
}

mat binpow(mat a, long long n)
{
	if(n==1)
	{
		return a;
	}else if(n%2==0)
	{
		return sqr(binpow(a, n/2));
	}else
	{
		return mult(sqr(binpow(a, n/2)), a);
	}
}

int main()
{
	long long n, i, j;

	cin >> n;

	if(n==1)
	{
		cout<<4;
		return 0;
	}else if(n==2)
	{
		cout<<18;
		return 0;
	}else if(n==3)
	{
		cout<<88;
		return 0;
	}

	mat m;

	m.a[0][0] = 0; m.a[0][1] = 0; m.a[0][2] = -4;
	m.a[1][0] = 1; m.a[1][1] = 0; m.a[1][2] = -22;
	m.a[2][0] = 0; m.a[2][1] = 1; m.a[2][2] = 10;
	
	mat res = binpow(m, n-3);

	long long result = res.a[0][2]*4 + res.a[1][2]*18 + res.a[2][2]*88;
	result%=MOD;

	cout<<result;

	return 0;
}